{This program shows an example of using a double-buffer and neat usage of
aliased objects in 640x480x8bpp}
{Written by TCA of NewOrder}

program alias4;
uses objgfx8,keys;

type PAobj=^Taobj;
     Taobj=object(Tgfx8)

           end;
var screen:PScreen8;  {screen object}
    dbuf:Pgfx8;     {double buffer object}
    aobj:Paobj;     {aliasing object}
    count:word;
    temp:word;
begin
 randomize;

 new(dbuf,init);
 new(aobj,init);

 with dbuf^ do
  if not getmem(640,480) then {make sure the buffer is allocated}
   begin
    writeln('Unable to allocate double buffer');
    halt
   end;

 {Alias a 320x200 section inside DBuf}
 aobj^.AliasGfx8(dbuf^,100,100,419,299);

 new(screen,init);

 with screen^ do  {Do some simple error checking}
  begin
   if not IsVesaInstalled=VESA_ok then
    begin
     writeln('No VESA BIOS');
     halt
    end;
   if not SetMode(_640x480x8bpp) then
    begin
     writeln('Cannot init 640x480x8bpp');
     halt
    end
  end;

  repeat
  with dbuf^ do
   begin
    clear(0);
    for count:=0 to 50 do  {Draw some random stuff}
     begin
      line(random(getmaxx),random(getmaxy),random(getmaxx),random(getmaxy),random(255));
      rectangle(random(getmaxx),random(getmaxy),random(getmaxx),random(getmaxy),random(255));
     end;
   end;
  with aobj^ do
   begin
    clear(0);
    for count:=0 to 20 do
      CubicBezierCurve(random(getmaxx),random(getmaxy),
                      random(getmaxx),random(getmaxy),
                      random(getmaxx),random(getmaxy),
                      random(getmaxx),random(getmaxy),
                      24,random(255));
   end;
  screen^.flip(dbuf^);
 until keypressed;

 dispose(screen,done);
 dispose(aobj,done);
 dispose(dbuf,done);
end.