program polygoned_cube;
uses ObjGfx0,objgfx8,keys;
const
  divd:word=128;
  dist=150;
  point:array[0..7,0..2] of integer=(
     (-40,-40,-40),(-40,-40,40),(40,-40,40),(40,-40,-40),
    (-40, 40,-40),(-40, 40,40),(40, 40,40),(40, 40,-40));
  planes:array[0..5,0..3] of byte=(
    (0,4,5,1),(0,3,7,4),(0,1,2,3),(4,5,6,7),(7,6,2,3),(1,2,6,5));

type TNewGfx8Buf=object(TGfx8)
       procedure averagepix(x,y:word);
     end;

type Tcube=object(TNewGfx8Buf)
      stab:array[0..319] of integer;
      polyz:array[0..5] of integer;
      pind:array[0..5] of byte;
      constructor init;
      procedure run;
      function cosinus(i:word):integer;
      function sinus(i:word):integer;
      procedure quicksort(lo,hi:integer);
      destructor done; virtual;
     end;
var
  screen:PScreen8;
  cube:^Tcube;

{$L firecube} {firecube.asm}
procedure TNewGfx8Buf.averagepix; external;
constructor Tcube.init;
var i:word;
begin
 inherited init;
 getmem(200,350);
 new(screen,init);
 screen^.setupmode(_640x480x8bpp);
 for i:=1 to 63 do screen^.setrgbpalette(i,i,i div 4,i div 4);
 for i:=1 to 63 do screen^.setrgbpalette(i+63,(63-i),(63-i) div 3,(63-i) div 4);
 for i:=0 to 319 do stab[i]:=round(sin(i*pi/128)*divd);
end;

{ -------------------------------------------------------------------------- }

function Tcube.cosinus(i:word):integer;
begin
 cosinus:=stab[i+64]
end;

function Tcube.sinus(i:word):integer;
begin
 sinus:=stab[i]
end;

{ -------------------------------------------------------------------------- }

procedure Tcube.quicksort(lo,hi:integer);

procedure sort(l,r:integer);
var i,j,x,y:integer;
begin
  i:=l; j:=r; x:=polyz[(l+r) div 2];
  repeat
    while polyz[i]<x do inc(i);
    while x<polyz[j] do dec(j);
    if i<=j then begin
      y:=polyz[i]; polyz[i]:=polyz[j]; polyz[j]:=y;
      y:=pind[i]; pind[i]:=pind[j]; pind[j]:=y;
      inc(i); dec(j);
    end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
end;

begin
 sort(lo,hi)
end;

{ -------------------------------------------------------------------------- }

procedure tcube.run;
const xst=1; yst=1 ; zst=1;
var
  xp,yp,zp:array[0..7] of integer;
  polypoints:array[0..3] of PointType;
  x,y,i,j,k,z:integer;
  n,phix,phiy,phiz:byte;
  count:word;
  xx,yy,temp:word;
begin
  phix:=0; phiy:=0; phiz:=0;
  repeat
    for yy:=1 to getmaxy-1 do
     for xx:=1 to getmaxx-1 do
      averagepix(xx,yy);

    for n:=0 to 7 do begin
      i:=(cosinus(phiy)*point[n,0]-sinus(phiy)*point[n,2]) div divd;
      j:=(cosinus(phiz)*point[n,1]-sinus(phiz)*i) div divd;
      k:=(cosinus(phiy)*point[n,2]+sinus(phiy)*point[n,0]) div divd;
      x:=(cosinus(phiz)*i+sinus(phiz)*point[n,1]) div divd;
      y:=(cosinus(phix)*j+sinus(phix)*k) div divd;
      z:=(cosinus(phix)*k-sinus(phix)*j) div divd;
      xp[n]:=(GetMaxX div 2)+(-x*dist) div (z-dist);
      yp[n]:=(GetMaxY div 2)+(-y*dist) div (z-dist);
      zp[n]:=z;
    end;
    for n:=0 to 5 do
     begin
      polyz[n]:=(zp[planes[n,0]]+zp[planes[n,1]]+zp[planes[n,2]]+zp[planes[n,3]]) div 4;
      pind[n]:=n
     end;
    quicksort(0,5);

    for n:=3 to 5  do
     begin
      for count:=0 to 3 do
       begin
        polypoints[count].x:=xp[planes[pind[n],count]];
        polypoints[count].y:=yp[planes[pind[n],count]]
       end;
      fillconvexpoly(4,polypoints,130-polyz[n])
     end;
    inc(phix,xst);
    inc(phiy,yst);
    inc(phiz,zst);
    if (screen^.getmaxx=getmaxx) and (screen^.getmaxy=getmaxy) then
     screen^.flip(self)
    else
     screen^.copybuf((screen^.getmaxx-getmaxx) div 2,(screen^.getmaxy-getmaxy) div 2,
                      self,0,0,getmaxx,getmaxy);
  until keypressed;
 while keypressed do readkey;
end;

destructor Tcube.done;
begin
 inherited done;
 dispose(screen,done)
end;

begin
 new(cube,init);
 cube^.run;
 dispose(cube,done)
end.
