{$A+,B-,D-,E+,F-,G+,I+,L+,N+,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0}
{
For all of you who are interested on fractals, here is a little program,
taken from a source code in Modula-2, that will draw a Mandelbrot fractal.

Just one problem: If your computer doesn't have a math coprocessor, the
program will run "a bit" slow :).

Try modifying all the constants, you'll get strange results :).
Written by Miguel Martnez.

Modified by TCA of NewOrder

}

Program Mandelbrot;     {Using real numbers. For TP 6.0 and above }

Uses ObjGfx8,Keys;

Const Colours=32;       {Number of colors to be on the image.     }
      Limit=8.0;        {Until when we calculate.                 }
      XRMin=-2.0;       {Left limit of the fractal.               }
      XRMax=1.0;        {Right limit of the fractal.              }
      YRMin=-1.3;       {Lower limit of the fractal.              }
      YRMax=1.3;        {Upper limit of the fractal.              }

Var XPos,YPos:Word;
    Screen:TScreen8;

{Calculates the color for each point.                             }
Function ComputeColour(XPos,YPos:Word):Byte;
Var RealP,ImagP:single;
    CurrX,CurrY:single;
    a2,b2:single;
    Counter:Byte;
Begin
  CurrX:=XPos/(Screen.GetMaxX+1)*(XRMax-XRMin)+XRMin;
  CurrY:=YPos/(Screen.GetMaxY+1)*(YRMax-YRMin)+YRMin;
  RealP:=0;
  ImagP:=0;
  Counter:=0;
  Repeat
    a2:=Sqr(RealP);
    b2:=Sqr(ImagP);
    ImagP:=2*RealP*ImagP+CurrY;
    RealP:=a2-b2+CurrX;
    Inc(Counter);
  Until (Counter>=Colours) or (a2+b2>=Limit);
  ComputeColour:=Counter-1;
End;

var i:word;
Begin
  Screen.Init;
  with screen do  {Do some simple error checking}
  begin
   if not IsVesaInstalled=VESA_ok then
    begin
     writeln('No VESA BIOS');
     halt
    end;
   if not SetMode(_640x480x8bpp) then
    begin
     writeln('Cannot init 640x480x8bpp');
     halt
    end
  end;

  For i:=0 to 15 do
  Begin
   screen.setrgbpalette(i,4*i+3,0,0);
   screen.setrgbpalette(i+16,63,4*i+3,0);
  end;

  with screen do
  For YPos:=0 to GetMaxY do
    For XPos:=0 to GetMaxX do
     begin
      PutPixel(XPos,YPos,computecolour(xpos,ypos));
      if keypressed then break;
     end;
  ReadKey;
  Screen.Done;
End.

