{This program shows an example of using a double-buffer in 640x480x8bpp}
{Written by TCA of NewOrder}
program example1;
uses objgfx8,keys;

var screen:PScreen8;
    Obj1:PGfx8;

    count,x,y:word;

begin
 randomize;

 new(screen,init);

 with screen^ do  {Do some simple error checking}
  begin
   if not IsVesaInstalled=VESA_ok then
    begin
     writeln('No VESA BIOS');
     halt
    end;
   if not IsModeAvailable(_640x480x8bpp) then
    begin
     writeln('Cannot init 640x480x8bpp');
     halt
    end;
  end;
 new(obj1,init);

 with obj1^ do
  if not getmem(640,480) then {make sure the buffer gets allocated}
   begin
    writeln('Cannot allocate double-buffer');
    halt
   end;

 screen^.SetupMode(_640x480x8bpp);  {Set and initialize the mode}

 {Set keyboard}
 SetKbdInterrupt;

 repeat
  with obj1^ do
  begin
   for count:=0 to 50 do  {Draw some random stuff}
    begin
     line(random(getmaxx),random(getmaxy),random(getmaxx),random(getmaxy),random(255));
     rectangle(random(getmaxx),random(getmaxy),random(getmaxx),random(getmaxy),random(255));
    end;
    for count:=0 to 64 do
     rectangle(32+count,32+count,128-count,128-count,count)
  end;
  screen^.flip(obj1^);
  obj1^.clear(0)
 until keypressed;
 readkey;

 {Restore the keyboard}
 RestoreKbdInterrupt;

 dispose(obj1,done);
 dispose(screen,done)
end.