{
poursand.pas

{ Pouring sand simulator - by Marcin Borkowski 2:480/25.
  VGA and patience required. Program simulates sand poured
  from some height on a flat surface. There are different
  grain densities and different grain colors - denser grains
  are darker. I saw something similar this year during winter
  vacation done from tho pieces of glass, water and sand - this
  program tries to simulate physical effects taking place in
  a real system. Denser grains falls faster and they form flatter
  slopes. ESC ends simulation. }

{ Program re-written by TCA of NewOrder}
uses objgfx8,keys;

const
  maxgrains = 199;

type
  data   = (x,y,c);

var
  sand   : array[0..maxgrains,x..c]of integer;
  bottom : array[0..639,0..1]of integer;
  grains,source : integer;

var screen:TScreen8;

procedure initsand;
begin
  fillchar(sand,sizeof(sand),#0);
  fillchar(bottom,sizeof(bottom),#0);
  grains:=0;
  source:=30+random(600);
  sand[grains,x]:=source;
  sand[grains,y]:=16*400;
  sand[grains,c]:=1;
end;

procedure movedown(i : integer);
var
  moved : boolean;
  j : integer;

  procedure totheleft;
  var
    j : integer;
  begin
    for j:=1 to sand[i,c] do
      if (sand[i,y]>bottom[sand[i,x]-j,0]+1) and (sand[i,x]>8) then
      begin
        dec(sand[i,x],j);
        sand[i,y]:=bottom[sand[i,x],0]+1;
        moved:=true;
        EXIT
      end;
  end;

  procedure totheright;
  var
    j : integer;
  begin
    for j:=1 to sand[i,c] do
      if (sand[i,y]>bottom[sand[i,x]+j,0]+1) and (sand[i,x]<632)  then
      begin
        inc(sand[i,x],j);
        sand[i,y]:=bottom[sand[i,x],0]+1;  {}
        moved:=true;
        EXIT
      end;
  end;

begin
  moved:=false;
  if random(2)<>0 then
  begin
    totheleft;
    if not moved then totheright;
  end
  else
  begin
    totheright;
    if not moved then totheleft;
  end;
  if moved then movedown(i)
end;

procedure pour;
var
  i : integer;
  px,py,pc : integer;
begin
  for i:=0 to grains do
  begin
    dec(sand[i,y],sand[i,c]);
    if sand[i,y] shr 4<=bottom[sand[i,x],0] then
    begin
      sand[i,y]:=bottom[sand[i,x],0]+1;
      movedown(i);
      px:=sand[i,x];
      py:=sand[i,y];
      pc:=sand[i,c];
      bottom[px,0]:=py;
      bottom[px,1]:=pc;
      screen.putpixel(px,screen.getmaxy-py,17-(pc shl 1));
      screen.putpixel(screen.getmaxx-px,py,17-(pc shl 1));
      if (screen.getmaxy-py)<300 then
       begin
        initsand;
        screen.clear(0);
        exit;
       end;
      move(sand[grains],sand[i],6);
      dec(grains);
    end;
  end;
  while grains<maxgrains do
  begin
    inc(grains);
    sand[grains,x]:=source;
    sand[grains,y]:=16*400;
    sand[grains,c]:=1+random(8);
  end;
{  if py>=100 then
   begin
    screen.clear(4);
    InitSand;
   end;}
end;

procedure colors16;
var
  i : integer;
begin
  for i:=0 to 15 do
   screen.setrgbpalette(i,3+4*i,3+4*i,3+4*i);
end;

begin
  screen.init;
  if not screen.SetMode(_640x480x8bpp) then
   begin
    writeln('Error initialzing video mode');
    halt
   end;
  randomize;
  colors16;
  InitSand;
  SetKbdInterrupt;
  repeat
    pour;
    if random(10000)>9997 then source:=30+random(600)
  until (keypressed) or (KeyHit[KY_ESC]) ;
  REstoreKbdINterrupt;
  screen.done;
end.
