(* ---------------------------- WAV3D.PAS ------------------------------- *)
(* Coded bye Jare/Iguana in 1993. Want more comment's? Write'em!          *)
(* Use this as you like; you're going to anyway, so who cares.            *)
(* But remember: proper crediting and greeting rules.                     *)

{ Rewritten by TCA of NewOrder for high-res}

USES keys,ObjGfx8;
const xsize=279;
      Radius=279.0;
TYPE
   TWavBuf = ARRAY [0..63, 0..127] OF BYTE;
   TLandBuf = ARRAY [0..31, 0..xsize] OF BYTE;

  (* -------------------- *)
type TEasterEgg=object(Tgfx8)
      Wb :^TWavBuf;
      lb :^TLandBuf;
      highest : ARRAY [0..xsize] OF BYTE;
      k:integer;
      constructor init;
      destructor done; virtual;
      procedure GenerateLand;
      procedure GenerateWav;
      procedure RunOnce;
     end;

CONST
   s31       = 31.0*31.0;
   MaxRadius = Radius*Radius + s31;
   s159       = Radius*Radius;


constructor TEasterEgg.Init;
begin
 inherited init;
 if not GetMem((xsize+1)*2,200) then exit;
 new(wb);
 new(lb);
 fillchar(highest,sizeof(highest),0);
 GenerateLand;
 GenerateWav;
 k:=0;
end;
destructor TEasterEgg.Done;
begin
 inherited done;
 dispose(wb);
 dispose(lb);
end;

procedure TEasterEgg.GenerateLand;
var i,j:integer;
begin
 for i := 0 to 31 do
  for j := 0 to xsize do
   begin
    lb^[i,j] := ROUND(SQRT((i+0.0)*i/s31 + (j+0.0)*j/s159)*127{/SQRT(2)});
    if lb^[i,j] > 127 then lb^[i,j] := 127
   end
END;

procedure TEasterEgg.GenerateWav;
var r, d, v, a : REAL;
    i,j:integer;
begin
 for j := 0 to 63 do
  for i := 0 to 127 do
   begin
    r := (i+1) * 5.0 * PI / 320.0;
    d := j * PI / 32.0;
    v := ((Sin(r - d)-Sin(-d)) / r ) - (Cos(r-d)/2);
    a := Cos(i*PI/2/128);
    Wb^[j, i] := BYTE(100 + ROUND(100.0 * a * a * v))
   end
end;

procedure TEasterEgg.RunOnce;
VAR i, j, n : INTEGER;
    c, lasth, limit : WORD;
begin
 n:=(k + 1) MOD 64;
 FOR j := 0 TO xsize DO
  begin
   c:=63+64;
   lasth := 199;
   for i := 31 downto 0 DO
    begin
     limit := 56+i+Wb^[n,Lb^[i,j]];
     WHILE lasth > limit DO
      begin
       putpixel(j+(xsize+1),lasth,c);
       putpixel(xsize-j,lasth,c);
       DEC(lasth)
      end;
     DEC(c)
    end;
   for i := 0 to 31 do
    begin
    limit := 55-i+Wb^[n,Lb^[i,j]];
     WHILE lasth > limit DO
      begin
       putpixel(j+(xsize+1),lasth,c);
       putpixel(xsize-j,lasth,c);
       DEC(lasth)
      end;
     DEC(c)
    end;
   for i := lasth downto highest[j] do
    begin
     putpixel(j+(xsize+1),i,0);
     putpixel(xsize-j,i,0)
    end;
    highest[j]:=lasth
  end;
  k:=n
end;
var screen:TScreen8;
    EasterEgg:TEasterEgg;
    w,v:word;
    c:byte;
BEGIN
 writeln('Calculating...');
 EasterEgg.Init;
 screen.init;
 screen.setupmode(_640x480x8bpp);
 setkbdinterrupt;
 for w:=63 to 127 do
  screen.setrgbpalette(w,0,0,w);
 EasterEgg.RunOnce;
 for v:=0 to EasterEgg.GetMaxY do
  with screen do
   begin
   line(0,((GetMaxY-EasterEgg.GetMaxY) shr 1)+v,
        (GetMaxX-EasterEgg.GetMaxX) shr 1,
        ((GetMaxY-EasterEgg.GetMaxY) shr 1)+v,EasterEgg.getpixel(0,v));
   line(GetMaxX,((GetMaxY-EasterEgg.GetMaxY) shr 1)+v,
        ((GetMaxX-EasterEgg.GetMaxX) shr 1)+EasterEgg.GetMaxX,
        ((GetMaxY-EasterEgg.GetMaxY) shr 1)+v,EasterEgg.getpixel(0,v));
   end;
  screen.copybuf((screen.GetMaxX-EasterEgg.GetMaxX) shr 1,
                 (Screen.GetMaxY-EasterEgg.GetMaxY) shr 1,
                 EasterEgg,0,0,EasterEgg.GetMaxX,EasterEgg.GetMaxY);

 repeat
  EasterEgg.RunOnce;
  screen.copybuf((screen.GetMaxX-EasterEgg.GetMaxX) shr 1,
                 (Screen.GetMaxY-EasterEgg.GetMaxY) shr 1,
                 EasterEgg,0,0,EasterEgg.GetMaxX,EasterEgg.GetMaxY);
 until keypressed;;
 RestoreKbdInterrupt;

 EasterEgg.Done;
 screen.done;
END.
