(* ---------------------------- WAV3D.PAS ------------------------------- *)
(* Coded bye Jare/Iguana in 1993. Want more comment's? Write'em!          *)
(* Use this as you like; you're going to anyway, so who cares.            *)
(* But remember: proper crediting and greeting rules.                     *)

{ Rewritten by TCA of NewOrder for high-res}
{ This version uses a separate buffer for mirroring}

USES keys,ObjGfx8;
const xsize=279;
      Radius=279.0;
TYPE
   TWavBuf = ARRAY [0..63, 0..127] OF BYTE;
   TLandBuf = ARRAY [0..31, 0..xsize] OF BYTE;

  (* -------------------- *)
type Tripple=object(Tgfx8)
      Buf:Tgfx8;

      Wb :^TWavBuf;
      lb :^TLandBuf;
      highest : ARRAY [0..xsize] OF BYTE;
      k:integer;
      constructor init;
      destructor done; virtual;
      procedure GenerateLand;
      procedure GenerateWav;
      procedure RunOnce;
     end;

CONST
   s31       = 31.0*31.0;
   MaxRadius = Radius*Radius + s31;
   s159       = Radius*Radius;


constructor Tripple.Init;
begin
 if not GetMem((xsize+1)*2,200) then exit;
 new(wb);
 new(lb);
 fillchar(highest,sizeof(highest),0);
 GenerateLand;
 GenerateWav;
 k:=0;
 buf.init;
 buf.aliasGfx8(self,(xsize+1),0,getmaxx,getmaxy);
end;
destructor Tripple.Done;
begin
 inherited done;
 buf.done;
 dispose(wb);
 dispose(lb);
end;

procedure Tripple.GenerateLand;
var i,j:integer;
begin
 for i := 0 to 31 do
  for j := 0 to xsize do
   begin
    lb^[i,j] := ROUND(SQRT((i+0.0)*i/s31 + (j+0.0)*j/s159)*127{/SQRT(2)});
    if lb^[i,j] > 127 then lb^[i,j] := 127
   end
END;

procedure Tripple.GenerateWav;
var r, d, v, a : REAL;
    i,j:integer;
begin
 for j := 0 to 63 do
  for i := 0 to 127 do
   begin
    r := (i+1) * 5.0 * PI / 320.0;
    d := j * PI / 32.0;
    v := ((Sin(r - d)-Sin(-d)) / r ) - (Cos(r-d)/2);
    a := Cos(i*PI/2/128);
    Wb^[j, i] := BYTE(100 + ROUND(100.0 * a * a * v))
   end
end;

procedure Tripple.RunOnce;
VAR i, j, n : INTEGER;
    c, lasth, limit : WORD;
begin
 n:=(k + 1) MOD 64;
 FOR j := 0 TO xsize DO
  begin
   c:=63+64;
   lasth := 199;
   for i := 31 downto 0 DO
    begin
     limit := 56+i+Wb^[n,Lb^[i,j]];
     WHILE lasth > limit DO
      begin
       putpixel(xsize-j,lasth,c);
       DEC(lasth)
      end;
     DEC(c)
    end;
   for i := 0 to 31 do
    begin
    limit := 55-i+Wb^[n,Lb^[i,j]];
     WHILE lasth > limit DO
      begin
       putpixel(xsize-j,lasth,c);
       DEC(lasth)
      end;
     DEC(c)
    end;
   if lasth>=highest[j] then
    vertline(xsize-j,lasth,highest[j],0);
   highest[j]:=lasth
  end;
 k:=n;

  buf.flip(self);
  buf.flipy;
end;
var screen:TScreen8;
    ripple:Tripple;
    w,v:word;
    c:byte;
BEGIN
 writeln('Calculating...');
 ripple.Init;
 screen.init;
 if not screen.setmode(_800x600x8bpp) then
  begin
   writeln('Error initializing graphics mode');
   halt;
  end;
 for w:=63 to 127 do
  screen.setrgbpalette(w,0,0,w);
 ripple.RunOnce;
 for v:=0 to ripple.GetMaxY do
  with screen do
   begin
   line(0,((GetMaxY-ripple.GetMaxY))+v,
        (GetMaxX-ripple.GetMaxX) shr 1,
        ((GetMaxY-ripple.GetMaxY))+v,ripple.getpixel(0,v));
   line(GetMaxX,((GetMaxY-ripple.GetMaxY))+v,
        ((GetMaxX-ripple.GetMaxX) shr 1)+ripple.GetMaxX,
        ((GetMaxY-ripple.GetMaxY))+v,ripple.getpixel(0,v));
   end;
  screen.copybuf((screen.GetMaxX-ripple.GetMaxX) shr 1,
                 (Screen.GetMaxY-ripple.GetMaxY),
                 ripple,0,0,ripple.GetMaxX,ripple.GetMaxY);

 repeat
  ripple.RunOnce;
  screen.copybuf((screen.GetMaxX-ripple.GetMaxX) shr 1,
                 (Screen.GetMaxY-ripple.GetMaxY),
                 ripple,0,0,ripple.GetMaxX,ripple.GetMaxY);
 until keypressed;
 while keypressed do readkey;
 ripple .Done;
 screen.done;
END.
