{$A+,B-,D+,E+,F-,G+,I+,L+,N-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0}
program rotationalfield;
{ Source by Bas van Gaalen, Holland, PD
  Modified for high-res by TCA of NewOrder
  A more accurate sine table would make the shape look better.
}
uses ObjGfx0,objgfx8,keys;
const
  dots = 459;
  dist : word = 250;
  sintab : array[byte] of integer = (
    0,3,6,9,13,16,19,22,25,28,31,34,37,40,43,46,49,52,55,58,60,63,66,68,
    71,74,76,79,81,84,86,88,91,93,95,97,99,101,103,105,106,108,110,111,
    113,114,116,117,118,119,121,122,122,123,124,125,126,126,127,127,127,
    128,128,128,128,128,128,128,127,127,127,126,126,125,124,123,122,122,
    121,119,118,117,116,114,113,111,110,108,106,105,103,101,99,97,95,93,
    91,88,86,84,81,79,76,74,71,68,66,63,60,58,55,52,49,46,43,40,37,34,31,
    28,25,22,19,16,13,9,6,3,0,-3,-6,-9,-13,-16,-19,-22,-25,-28,-31,-34,
    -37,-40,-43,-46,-49,-52,-55,-58,-60,-63,-66,-68,-71,-74,-76,-79,-81,
    -84,-86,-88,-91,-93,-95,-97,-99,-101,-103,-105,-106,-108,-110,-111,
    -113,-114,-116,-117,-118,-119,-121,-122,-122,-123,-124,-125,-126,
    -126,-127,-127,-127,-128,-128,-128,-128,-128,-128,-128,-127,-127,
    -127,-126,-126,-125,-124,-123,-122,-122,-121,-119,-118,-117,-116,
    -114,-113,-111,-110,-108,-106,-105,-103,-101,-99,-97,-95,-93,-91,
    -88,-86,-84,-81,-79,-76,-74,-71,-68,-66,-63,-60,-58,-55,-52,-49,
    -46,-43,-40,-37,-34,-31,-28,-25,-22,-19,-16,-13,-9,-6,-3);
type
  dotpos = array[0..dots] of pointType3d;

type TDbuf=object(Tgfx8)
            dot : dotpos;
            xp:array[0..dots] of word;
            yp:array[0..dots] of word;
            zp:array[0..dots] of word;
            constructor init;
            procedure run;
            destructor done; virtual;
     end;

var screen:TScreen8;
var dbuf:TDbuf;

{----------------------------------------------------------------------------}

constructor TDbuf.init;
var i : word; x,z : integer;
begin
 inherited init;
 if not getmem(340,200) then
  begin
   writeln('Error allocating double-buffer');
   halt
  end;
 Screen.init;
 with screen do  {Do some simple error checking}
  begin
   if not IsVesaInstalled=VESA_ok then
    begin
     writeln('No VESA BIOS');
     halt
    end;
   if not SetMode(_640x480x8bpp) then
    begin
     writeln('Cannot init 640x480x8bpp');
     halt
    end
  end;
  clear(0);
  i := 0;
  z := -100;
  while z < 100 do begin
    x := -100;
    while x < 100 do begin
      dot[i].x := x;
      dot[i].y := -45;
      dot[i].z := z;
      inc(i);
      inc(x,10);
    end;
    inc(z,9);
  end;
  screen.setrgbpalette(0,4,0,4);
  for i := 1 to 63 do screen.setrgbpalette(i,i,(i div 2),i);
  for i:=64 to 255 do screen.setrgbpalette(i,0,0,0);
end;

{----------------------------------------------------------------------------}

procedure TDBuf.run;
const yst = 1;
var
  x,z:integer;
  n,nx,ny,cx,cy:word;
  phiy:byte;
  poly:array[0..3] of PointType;
  idx:word;
begin
 phiy:=0;
 SetKbdINterrupt;
 cx:=(getmaxx div 2);
 cy:=(getmaxy div 2);
 repeat
  clear(0);
   for n := 0 to dots do
    begin

      x := (sintab[byte(phiy+192)] * dot[n].x
            - sintab[phiy] * dot[n].z) div 128;

      z := (sintab[byte(phiy+192)]*dot[n].z+sintab[phiy]*dot[n].x) div 128;

      xp[n] :=(x*dist) div (z-dist);
      yp[n] :=(dot[n].y*dist) div (z-dist);
      zp[n]:=(z shr 2)+28;
    end;
   for ny:=0 to 21 do
    for nx:=0 to 18 do
     begin
      idx:=ny*20+nx;
      poly[0].x:=xp[idx]+cx;
      poly[0].y:=yp[idx]+cy;
      poly[1].x:=xp[idx+1]+cx;
      poly[1].y:=yp[idx+1]+cy;
      idx:=(ny+1)*20+nx+1;
      poly[2].x:=xp[idx]+cx;
      poly[2].y:=yp[idx]+cy;
      poly[3].x:=xp[idx-1]+cx;
      poly[3].y:=yp[idx-1]+cy;
      fillconvexpoly(4,poly,zp[ny*20+nx]);
     end;
   inc(phiy);
   screen.copybuf((screen.getmaxx-getmaxx) shr 1,(screen.getmaxy-getmaxy) shr 1,
                  self,0,0,getmaxx,getmaxy);
  until keypressed or (KeyHit[KY_ESC]);
 RestoreKbdInterrupt;
end;

destructor TDbuf.done;
begin
 inherited done;
 screen.done;
end;
{----------------------------------------------------------------------------}

begin
 Dbuf.init;
 Dbuf.Run;
 Dbuf.done
end.
