{$A+,B-,D+,E+,F-,G+,I+,L+,N-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0}
program rotationalfield;
{ Source by Bas van Gaalen, Holland, PD }
{ Modified slightly for high-res by TCA of NewOrder}

uses ObjGfx0,ObjGfx8,keys;

const
  dots = 459;
  dist : word = 250;
  sintab : array[0..255] of integer = (
    0,3,6,9,13,16,19,22,25,28,31,34,37,40,43,46,49,52,55,58,60,63,66,68,
    71,74,76,79,81,84,86,88,91,93,95,97,99,101,103,105,106,108,110,111,
    113,114,116,117,118,119,121,122,122,123,124,125,126,126,127,127,127,
    128,128,128,128,128,128,128,127,127,127,126,126,125,124,123,122,122,
    121,119,118,117,116,114,113,111,110,108,106,105,103,101,99,97,95,93,
    91,88,86,84,81,79,76,74,71,68,66,63,60,58,55,52,49,46,43,40,37,34,31,
    28,25,22,19,16,13,9,6,3,0,-3,-6,-9,-13,-16,-19,-22,-25,-28,-31,-34,
    -37,-40,-43,-46,-49,-52,-55,-58,-60,-63,-66,-68,-71,-74,-76,-79,-81,
    -84,-86,-88,-91,-93,-95,-97,-99,-101,-103,-105,-106,-108,-110,-111,
    -113,-114,-116,-117,-118,-119,-121,-122,-122,-123,-124,-125,-126,
    -126,-127,-127,-127,-128,-128,-128,-128,-128,-128,-128,-127,-127,
    -127,-126,-126,-125,-124,-123,-122,-122,-121,-119,-118,-117,-116,
    -114,-113,-111,-110,-108,-106,-105,-103,-101,-99,-97,-95,-93,-91,
    -88,-86,-84,-81,-79,-76,-74,-71,-68,-66,-63,-60,-58,-55,-52,-49,
    -46,-43,-40,-37,-34,-31,-28,-25,-22,-19,-16,-13,-9,-6,-3);
type
  dotrec = record x,y,z : integer; end;
  dotpos = array[0..dots] of PointType3d;
var dot : dotpos;
    screen:TScreen8;
procedure init;
var i : word; x,z : integer;
begin
  i := 0;
  z := -100;
  while z < 100 do begin
    x := -100;
    while x < 100 do begin
      dot[i].x := x;
      dot[i].y := -45;
      dot[i].z := z;
      inc(i);
      inc(x,10);
    end;
    inc(z,9);
  end;
  for i := 0 to 63 do screen.setRGBpalette(i,0,i,i);
  for i := 64 to 255 do screen.setRGBpalette(i,0,0,0);
end;

procedure rotation;
const yst = 1;
var
  xp : array[0..dots] of word;
  yp : array[0..dots] of word;
  x,z : integer; n : word; phiy : byte;
  cx,cy:word;
begin
  phiy:=0;
  cx:=screen.getmaxx div 2;
  cy:=Screen.GetmaxY div 2;
  SetKbdINterrupt;
  with screen do
  repeat
   waitforretrace;
   line(xp[0],yp[0],xp[19],yp[19],0);
   line(xp[19],yp[19],xp[dots],yp[dots],0);
   line(xp[dots],yp[dots],xp[dots-19],yp[dots-19],0);
   line(xp[dots-19],yp[dots-19],xp[0],yp[0],0);
   for n := 0 to dots do
     begin
      putpixel(xp[n],yp[n],0);
      x := (sintab[(phiy+192) mod 255] * dot[n].x

            - sintab[phiy] * dot[n].z) div 128;
      z := (sintab[(phiy+192) mod 255]*dot[n].z+sintab[phiy]*dot[n].x) div 128;
      xp[n] := cx+(x*dist) div (z-dist);
      yp[n] := cy+(dot[n].y*dist) div (z-dist);
      putpixel(xp[n],yp[n],z shr 3+28);
     end;
   line(cx,cy+40,cx,screen.getmaxy-40,15);
   line(xp[0],yp[0],xp[19],yp[19],33);
   line(xp[19],yp[19],xp[dots],yp[dots],33);
   line(xp[dots],yp[dots],xp[dots-19],yp[dots-19],33);
   line(xp[dots-19],yp[dots-19],xp[0],yp[0],33);
   line(cx,90,cx,cy+40,15);
    inc(phiy);
  until (keypressed) or (KeyHit[KY_ESC]);
  RestoreKbdInterrupt;
end;

{----------------------------------------------------------------------------}

begin
 Screen.init;
 with screen do  {Do some simple error checking}
  begin
   if not IsVesaInstalled=VESA_ok then
    begin
     writeln('No VESA BIOS');
     halt
    end;
   if not SetMode(_640x480x8bpp) then
    begin
     writeln('Cannot init 640x480x8bpp');
     halt
    end
  end;
 Init;
 rotation;
 Screen.Done;
end.
