program scale; { SCALE.PAS }

uses objgfx8,keys;
const
  picfile='SANDRA.MSH';  {mmmmm. Sandra Bullock}
  dir:shortint=4;
  ptab:array[0..255] of word=(
    123,121,119,117,115,114,112,110,108,106,104,103,101,99,97,96,94,92,91,
    89,87,86,84,82,81,79,78,76,75,73,72,70,69,67,66,64,63,62,60,59,58,56,
    55,54,52,51,50,49,48,46,45,44,43,42,41,39,38,37,36,35,34,33,32,31,30,
    29,28,27,26,26,25,24,23,22,21,21,20,19,18,17,17,16,15,15,14,13,13,12,
    12,11,10,10,9,9,8,8,7,7,6,6,5,5,5,4,4,4,3,3,3,2,2,2,2,1,1,1,1,1,1,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,5,5,6,6,
    7,7,7,8,8,9,9,10,11,11,12,12,13,14,14,15,16,16,17,18,19,19,20,21,22,
    23,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,
    46,47,48,49,51,52,53,54,56,57,58,60,61,62,64,65,67,68,69,71,72,74,75,
    77,78,80,82,83,85,86,88,90,91,93,95,96,98,100,102,103,105,107,109,111,
    113,114,116,118,120,122,124,126);

var
  xobj,i,j:word;
  vx,vy,vx2,vy2, { virtual }
  x,y,x2,y2, { real }
  px,py,px2,py2:integer; { previous }
  pidx,k:byte;

  screen:TScreen8;
  buf:Tgfx8;
  pic:Tgfx8;
function min(left,right:integer):integer;
begin
  if left<=right then min:=left else min:=right;
end;

function max(left,right:integer):integer;
begin
 if left<=right then max:=right else max:=left;
end;
begin
  pic.init;
  buf.init;
  if not buf.getmem(640,480) then
   begin
    writeln('Error allocating memory for double buffer');
    halt
   end;
   if not pic.loadgfx(picfile) then
   begin
    writeln('Error loading image file: ',picfile);
    halt
   end;
  screen.init;
  screen.setupmode(_640x480x8bpp);
  screen.strippal(picfile);
  screen.makepal;
  for j:=0 to 255 do
   ptab[j]:=ptab[j]*2+36;
  { bump'n'scale picture }
  pidx:=128; px:=0; py:=0; px2:=0; py2:=0; vx:=10;
  repeat
    if (vx<=-50) or (vx>=(buf.getmaxx-(180))) then dir:=-dir; { calculate virtual positions }
    vy:=ptab[pidx];
    vy2:=vy+(pic.getmaxy shr 1);
    inc(pidx,4);
    if vy2<buf.getmaxy then inc(vx,dir);
    vx2:=vx+(pic.getmaxx shr 1);
    x:=vx;
    if x<0 then x:=0; { derive screen positions }
    x2:=vx2;
    if x2>buf.getmaxx then x2:=buf.getmaxx;
    y:=vy;
    y2:=vy2;
    if y2>buf.getmaxy then y2:=buf.getmaxy;
    buf.scalebuf(x,y,x2,y2,pic,0,0,pic.getmaxx,pic.getmaxy);
    screen.copybuf(min(x,px),min(y,py),buf,
                   max(min(x,px),0),max(min(y,py),0),
                   min(max(x2,px2),screen.getmaxx),min(max(y2,py2),screen.getmaxy));
    px:=x; px2:=x2; py:=y; py2:=y2; { set previous coords }
    buf.bar(x,y,x2,y2,0);
    screen.waitforretrace;
  until keypressed;
  readkey;

  screen.clear(0);

  i:=0; j:=0;
  repeat
    screen.scalebuf(0,0,i,j,pic,0,0,pic.getmaxx,pic.getmaxy);
    if i<screen.getmaxx then inc(i,3) else i:=screen.getmaxx;
    inc(j,2);
  until keypressed or (j>screen.getmaxy);
  readkey;
  if keypressed then readkey;
  screen.done;
  buf.done;
  pic.done;
end.
