{ WORMHOLE originally done by Ansgar Scherp, Joachim Gelhaus}
{ redone by TCA of NewOrder}
program ObjGfx_wormhole;
uses keys,ObjGfx0,objgfx8;
const divd=128;
      xst=3; yst=2;  {move left/right and up/down}
      PointsPerRing=40;
      NumOfRings=28;
      Astep=360 div PointsPerRing;
type TWormhole=object(Tgfx8)
      screen:PScreen8;
      sintab:array[0..449] of integer;
      stab,ctab:array[0..255] of integer;
      px,py : array[0..NumOfRings-1,0..PointsPerRing-1] of integer;
      ring,point,DrawMode: byte;
      constructor init;
      procedure draw;
      procedure run;
      destructor done; virtual;
     end;

var WormHole:^TWormhole;

constructor Twormhole.init;
var i:word;
begin
 inherited init;
 if not getmem(320,240) then
  begin
   writeln('Unable to allocate memory');
   halt
  end;
 new(screen,init);
 for i:=0 to 255 do
  begin
   ctab[i]:=round(cos(pi*i/128)*60);
   stab[i]:=round(sin(pi*i/128)*45)
  end;
 for i:=0 to 449 do sintab[i]:=round(sin(2*pi*i/360)*divd);
 with screen^ do
  begin
   setupmode(_640x480x8bpp);
   for i:=1 to 31 do
    setRGBpalette(i,i*2,0,63-(i*2))
  end
end;

procedure tWormhole.draw;
var ri,po:word;
    points:array[0..3] of pointtype;
begin
 case DrawMode of
   0:for ri := 0 to NumOfRings-1 do {27-Rings}
      for po := 0 to PointsPerRing-1 do {points}
        putpixel(px[ri,po],py[ri,po],ri+1);
   1:for ri := 0 to NumOfRings-1 do
      begin{27-Rings}
       for po := 1 to PointsPerRing-1 do
        line(px[ri,po-1],py[ri,po-1],px[ri,po],py[ri,po],ri+1);
       line(px[ri,pointsPerRing-1],py[ri,pointsPerRing-1],px[ri,0],py[ri,0],ri+1)
      end;
   2:for po := 0 to PointsPerRing-1 do
      for ri := 1 to NumOfRings-1 do
       line(px[ri-1,po],py[ri-1,po],px[ri,po],py[ri,po],ri+1);
   3:begin
      for ri := NumOfRings-1 downto 0 do
       begin{27-Rings}
        for po := 1 to PointsPerRing-1 do
         line(px[ri,po-1],py[ri,po-1],px[ri,po],py[ri,po],ri+1);
        line(px[ri,PointsPerRing-1],py[ri,PointsPerRing-1],px[ri,0],py[ri,0],ri+1);
       end;
      for po := 0 to PointsPerRing-1 do
       for ri :=NumOfRings-1 downto 1 do
        line(px[ri-1,po],py[ri-1,po],px[ri,po],py[ri,po],ri+1)
     end;
   4:for ri := 0 to NumOfRings-2 do
      begin
       for po := 1 to PointsPerRing-1 do
        begin
         points[0].x:=px[ri,po-1];
         points[0].y:=py[ri,po-1];
         points[1].x:=px[ri,po];
         points[1].y:=py[ri,po];
         points[2].x:=px[ri+1,po];
         points[2].y:=py[ri+1,po];
         points[3].x:=px[ri+1,po-1];
         points[3].y:=py[ri+1,po-1];
         FillConvexPoly(4,Points,ri+1);
        end;
         points[0].x:=px[ri,PointsPerRing-1];
         points[0].y:=py[ri,PointsPerRing-1];
         points[1].x:=px[ri,0];
         points[1].y:=py[ri,0];
         points[2].x:=px[ri+1,0];
         points[2].y:=py[ri+1,0];
         points[3].x:=px[ri+1,PointsPerRing-1];
         points[3].y:=py[ri+1,PointsPerRing-1];
         FillConvexPoly(4,Points,ri+1);
       end;

  end;
end;

procedure tWormhole.run;
var Finished:boolean;
    lstep:byte;
    ky:byte;
    i,j,x,y,midx,midy:word;
begin
 SetKbdInterrupt;
 Finished:=FALSE;
 x:=90;
 y:=30;
 midx:=(getmaxx+1) div 2;
 midy:=(getmaxy+1) div 2;
 DrawMode:=0;
 repeat
  lstep:=2;
  j:=10;
  ring:=0;
  while ring<NumOfRings do
   begin
    i:=0;
    point:=0;
    while point<PointsPerRing do
     begin
      px[ring,point]:=midx+ctab[byte((x+(200-j)))]+(j*sintab[90+i]) div (divd-20);
      py[ring,point]:=midy+stab[byte((y+(200-j)))]+(j*sintab[i]) shr 7;
      inc(i,astep);
      inc(point)
     end;
    inc(j,lstep);
    if (j mod 3)=0 then inc(lstep);
    inc(ring)
   end;
  x:=xst+x mod 255;
  y:=yst+y mod 255;
  clear(0);
  draw;
{  screen^.flip(self);}
  screen^.copybuf(0,0,self,0,0,getmaxx,getmaxy);
  flipy;
  screen^.copybuf((GetMaxX+1),0,self,0,0,getmaxx,getmaxy);
  flipx;
  screen^.copybuf((GetMaxX+1),(getMaxY+1),self,0,0,getmaxx,getmaxy);
  flipy;
  screen^.copybuf(0,(GetMaxY+1),self,0,0,getmaxx,getmaxy);
  if keypressed then
   begin
    ky:=readScanCode;
    case ky of
     KY_1..KY_5:DrawMode:=ky-2;
     KY_ESC:finished:=TRUE;
    end
   end;
  until (Finished) or KeyHit[KY_ESC];
  RestoreKbdInterrupt;
end;

destructor Twormhole.done;
begin
 inherited done;
 dispose(screen,done);
 writeln('Originally done by Ansgar Scherp and Joachim Gelhaus');
 writeln('Re-written by TCA of NewOrder');
end;

begin
 new(wormhole,init);
 wormhole^.run;
 dispose(wormhole,done)
end.